#include <stdlib.h>
#include <time.h>
#include <signal.h>
#include "prodcon.h"

//signalhandler
void sighandler(int sig)
{
    printf("Signal %d caught\n", sig);
    //close monitor and exit
    closeMonitor();
    exit(1);
}

//code for the producer
//there is one argument, the maximal interval for the producer
int main(int argc, char **argv)
{
    int item;     //produced item
    int interval; //maximal interval between production of items

    //exactly one argument
    if(argc != 2)
	exit(1);

    //get argument
    interval = atoi(argv[1]); 

    //is the argument valid?
    if(interval <= 0)
	exit(1);

    //SIGTERM and SIGINT are handled by sighandler
    signal(SIGTERM, sighandler);
    signal(SIGINT, sighandler);
    
    //open monitor
    openMonitor();
    //initialize random number generator
    srandom(time(NULL)+getpid());

    //do forever
    while(1)
    {
	//sleep some time
	sleep(random()%interval);
	//produce
	item = random()%100;
	//put item into buffer
	printf("Producer:\n");
	insertItem(item);
	printf("          put %d\n",item);
    }
}



